#!/usr/bin/sh
#
# 	Part of kde-service-menu-pdf Version 0.6
# 	Copyright (C) 2014 Giuseppe Benigno <giuseppe.benigno(at)gmail.com>
#
# 	This program is free software: you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation, either version 3 of the License, or
# 	(at your option) any later version.
#
# 	This program is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

lang=`echo "${1}" | sed -e "s/@//g"`
shift
action="${1}"
shift
workDir="${1%/*}"; if [ ! -d "${workDir}" ]; then workDir="./"; fi
fileName="${1##*/}"
baseFileName="${fileName%.*}"

#### languages strings messages #################
# Syntax for strings name is: msg_[$action]_$window_[$section]
# For languages as sr@Latn use srLatn

load_language_en () {
	msg_optimize_pdfsettings_title="Document resolution"
	msg_optimize_pdfsettings_text="Choose resolution"
	msg_optimize_initial_outputFileName="${workDir}/${baseFileName} (optimized).pdf"
	msg_optimize_saveFile_title="Save document"
	msg_optimize_finish_title="Optimization of document \"${baseFileName}\""
	msg_optimize_finish="Done."

	msg_createDir_error="Unable to create the images destination directory!"
	msg_png_destDir_16m="${workDir}/${baseFileName} (full color png)"
	msg_png_destDir_256="${workDir}/${baseFileName} (256 colors png)"
	msg_png_destDir_16="${workDir}/${baseFileName} (16 color png)"
	msg_png_destDir_gray="${workDir}/${baseFileName} (gray png)"
	msg_png_destDir_mono="${workDir}/${baseFileName} (mono png)"
	msg_png_destDir_alpha="${workDir}/${baseFileName} (transparency png)"
	msg_png_dpi_title="Input DPI for \"${baseFileName}\""
	msg_png_dpi_text="Please write DPI resolution for images. Normal screen have 72x72 DPI."
	msg_png_finish_title="Conversion of document \"${baseFileName}\""
	msg_png_finish="Done."

	msg_jpg_destDir_gray="${workDir}/${baseFileName} (gray jpeg)"
	msg_jpg_destDir_color="${workDir}/${baseFileName} (color jpeg)"
	msg_jpg_dpi_title="Input DPI for \"${baseFileName}\""
	msg_jpg_dpi_text="Please write DPI resolution for images. Normal screen have 72x72 DPI."
	msg_jpg_finish_title="Conversion of document \"${baseFileName}\""
	msg_jpg_finish="Done."

	msg_fax_destDir_tiffg3="${workDir}/${baseFileName} (G3 fax encoding)"
	msg_fax_destDir_tiffg32d="${workDir}/${baseFileName} (2-D G3 fax encoding)"
	msg_fax_destDir_tiffg4="${workDir}/${baseFileName} (G4 fax encoding)"
	msg_fax_finish_title="Conversion of document \"${baseFileName}\""
	msg_fax_finish="Done."
}

load_language_it () {
	msg_optimize_pdfsettings_title="Risoluzione del documento"
	msg_optimize_pdfsettings_text="Scegli la risoluzione desiderata"
	msg_optimize_initial_outputFileName="${workDir}/${baseFileName} (ottimizzato).pdf"
	msg_optimize_saveFile_title="Salva documento"
	msg_optimize_finish_title="Ottimizzazione del documento \"${baseFileName}\""
	msg_optimize_finish="Conclusa."

	msg_createDir_error="Non é possibile creare la directory di destinazione per le immagini!"
	msg_png_destDir_16m="${workDir}/${baseFileName} (png con tutti i colori)"
	msg_png_destDir_256="${workDir}/${baseFileName} (png con 256 colori)"
	msg_png_destDir_16="${workDir}/${baseFileName} (png con 16 colori)"
	msg_png_destDir_gray="${workDir}/${baseFileName} (png toni di grigio)"
	msg_png_destDir_mono="${workDir}/${baseFileName} (png bianco e nero)"
	msg_png_destDir_alpha="${workDir}/${baseFileName} (png con trasparenza)"
	msg_png_dpi_title="Inserimento DPI per \"${baseFileName}\""
	msg_png_dpi_text="Per favore scrivi la risoluzione in DPI per le immagini. Gli schermi normali hanno una risoluzione di 72x72 DPI."
	msg_png_finish_title="Conversione del documento \"${baseFileName}\""
	msg_png_finish="Completata."

	msg_jpg_destDir_gray="${workDir}/${baseFileName} (jpeg in toni di grigio)"
	msg_jpg_destDir_color="${workDir}/${baseFileName} (jpeg a colori)"
	msg_jpg_dpi_title="Inserimento DPI per \"${baseFileName}\""
	msg_jpg_dpi_text="Per favore scrivi la risoluzione in DPI per le immagini. Gli schermi normali hanno una risoluzione di 72x72 DPI."
	msg_jpg_finish_title="Conversione del documento \"${baseFileName}\""
	msg_jpg_finish="Completata."

	msg_fax_destDir_tiffg3="${workDir}/${baseFileName} (codifica fax G3)"
	msg_fax_destDir_tiffg32d="${workDir}/${baseFileName} (codifica fax 2-D G3)"
	msg_fax_destDir_tiffg4="${workDir}/${baseFileName} (codifica fax G4)"
	msg_fax_finish_title="Conversione del documento \"${baseFileName}\""
	msg_fax_finish="Completata."
}

load_language_de () {
	msg_optimize_pdfsettings_title="Auflösung"
	msg_optimize_pdfsettings_text="Auflösung auswählen"
	msg_optimize_initial_outputFileName="${workDir}/${baseFileName} (optimiert).pdf"
	msg_optimize_saveFile_title="Dokument speichern"
	msg_optimize_finish_title="Optimierung von \"${baseFileName}\""
	msg_optimize_finish="Fertig."

	msg_createDir_error="Kann Zielverzeichnis für die Bilddateien nicht erstellen!"
	msg_png_destDir_16m="${workDir}/${baseFileName} (alle farben png)"
	msg_png_destDir_256="${workDir}/${baseFileName} (256 farben png)"
	msg_png_destDir_16="${workDir}/${baseFileName} (16 farben png)"
	msg_png_destDir_gray="${workDir}/${baseFileName} (grau png)"
	msg_png_destDir_mono="${workDir}/${baseFileName} (mono png)"
	msg_png_destDir_alpha="${workDir}/${baseFileName} (transparentes png)"
	msg_png_dpi_title="DPI für eingeben\"${baseFileName}\""
	msg_png_dpi_text="Bitte geben Sie die DPI Auflösung für die Bilder ein. Normale Bildschirme haben 72x72 DPI."
	msg_png_finish_title="Umwandlung des Dokuments \"${baseFileName}\""
	msg_png_finish="Fertig."

	msg_jpg_destDir_gray="${workDir}/${baseFileName} (grau jpeg)"
	msg_jpg_destDir_color="${workDir}/${baseFileName} (farbe jpeg)"
	msg_jpg_dpi_title="DPI für eingeben \"${baseFileName}\""
	msg_jpg_dpi_text="Bitte geben Sie die DPI Auflösung für die Bilder ein. Normale Bildschirme haben 72x72 DPI."
	msg_jpg_finish_title="Umwandlung des Dokuments \"${baseFileName}\""
	msg_jpg_finish="Fertig."

	msg_fax_destDir_tiffg3="${workDir}/${baseFileName} (G3 fax encoding)"
	msg_fax_destDir_tiffg32d="${workDir}/${baseFileName} (2-D G3 fax encoding)"
	msg_fax_destDir_tiffg4="${workDir}/${baseFileName} (G4 fax encoding)"
	msg_fax_finish_title="Umwandlung des Dokuments \"${baseFileName}\""
	msg_fax_finish="Fertig."
}

load_language_ru () {
	msg_optimize_pdfsettings_title="Разрешение документа"
	msg_optimize_pdfsettings_text="Выбрать разрешение"
	msg_optimize_initial_outputFileName="${workDir}/${baseFileName} (оптимизированный).pdf"
	msg_optimize_saveFile_title="Сохранить документ"
	msg_optimize_finish_title="Оптимизация документа \"${baseFileName}\""
	msg_optimize_finish="Готово."

	msg_createDir_error="Невозможно создать каталог назначения!"
	msg_png_destDir_16m="${workDir}/${baseFileName} (Полноцветный png)"
	msg_png_destDir_256="${workDir}/${baseFileName} (256 цветов png)"
	msg_png_destDir_16="${workDir}/${baseFileName} (16 цветов png)"
	msg_png_destDir_gray="${workDir}/${baseFileName} (Серый png)"
	msg_png_destDir_mono="${workDir}/${baseFileName} (Моно png)"
	msg_png_destDir_alpha="${workDir}/${baseFileName} (Прозрачный png)"
	msg_png_dpi_title="Икпорт DPI для \"${baseFileName}\""
	msg_png_dpi_text="Пожалуйста, напишите DPI разрешение для изображений. Нормальный экран 72x72 DPI."
	msg_png_finish_title="Преобразование документа \"${baseFileName}\""
	msg_png_finish="Готово."

	msg_jpg_destDir_gray="${workDir}/${baseFileName} (Серый jpeg)"
	msg_jpg_destDir_color="${workDir}/${baseFileName} (Цветной jpeg)"
	msg_jpg_dpi_title="Икпорт DPI для \"${baseFileName}\""
	msg_jpg_dpi_text="Пожалуйста, напишите DPI разрешение для изображений. Нормальный экран 72x72 DPI."
	msg_jpg_finish_title="Преобразование документа \"${baseFileName}\""
	msg_jpg_finish="Готово."

	msg_fax_destDir_tiffg3="${workDir}/${baseFileName} (Кодирование факс G3)"
	msg_fax_destDir_tiffg32d="${workDir}/${baseFileName} (Кодирование факс 2-D G3)"
	msg_fax_destDir_tiffg4="${workDir}/${baseFileName} (Кодирование факс G4)"
	msg_fax_finish_title="Преобразование документа \"${baseFileName}\""
	msg_fax_finish="Готово."
}

################################################

optimize () {
	pdfsettings=`kdialog --caption "${msg_optimize_pdfsettings_title}" --icon configure --combobox "${msg_optimize_pdfsettings_text}" screen default ebook printer prepress` || exit
	if [ -z "${pdfsettings}" ]; then pdfsettings='default'; fi
	outputFileName="`kdialog --title "${msg_optimize_saveFile_title}" --caption "${msg_optimize_saveFile_title}" --icon document-save --getsavefilename "${msg_optimize_initial_outputFileName}" application/pdf`" || exit
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=pdfwrite -dPDFSETTINGS="/${pdfsettings}" -sOutputFile="${outputFileName}" "${1}" && \
	kdialog --title "${msg_optimize_finish_title}" --passivepopup "${msg_optimize_finish}" 5
}

################################################

#kdialog --radiolist "Colors of images" png16m "Full colors" on png256 "256 colors"off png16 "16 colors" off pnggray "Gray tones" off pngmono "mono (black and white)" pngalpha "With transparency" off

png16m () {
	dpi=`kdialog --title "${msg_png_dpi_title}" --caption "${msg_png_dpi_title}" --icon configure --inputbox "${msg_png_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_png_destDir_16m}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=png16m -r"${dpi}" -sOutputFile="${msg_png_destDir_16m}/page_%0d.png" "${1}" && \
	kdialog --title "${msg_png_finish_title}" --passivepopup "${msg_png_finish}" 5
}

png256 () {
	dpi=`kdialog --title "${msg_png_dpi_title}" --caption "${msg_png_dpi_title}" --icon configure --inputbox "${msg_png_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_png_destDir_256}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=png256 -r"${dpi}" -sOutputFile="${msg_png_destDir_256}/page_%0d.png" "${1}" && \
	kdialog --title "${msg_png_finish_title}" --passivepopup "${msg_png_finish}" 5
}

png16 () {
	dpi=`kdialog --title "${msg_png_dpi_title}" --caption "${msg_png_dpi_title}" --icon configure --inputbox "${msg_png_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_png_destDir_16}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=png16 -r"${dpi}" -sOutputFile="${msg_png_destDir_16}/page_%0d.png" "${1}" && \
	kdialog --title "${msg_png_finish_title}" --passivepopup "${msg_png_finish}" 5
}

pnggray () {
	dpi=`kdialog --title "${msg_png_dpi_title}" --caption "${msg_png_dpi_title}" --icon configure --inputbox "${msg_png_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_png_destDir_gray}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=pnggray -r"${dpi}" -sOutputFile="${msg_png_destDir_gray}/page_%0d.png" "${1}" && \
	kdialog --title "${msg_png_finish_title}" --passivepopup "${msg_png_finish}" 5
}

pngmono () {
	dpi=`kdialog --title "${msg_png_dpi_title}" --caption "${msg_png_dpi_title}" --icon configure --inputbox "${msg_png_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_png_destDir_mono}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=pngmono -r"${dpi}" -sOutputFile="${msg_png_destDir_mono}/page_%0d.png" "${1}" && \
	kdialog --title "${msg_png_finish_title}" --passivepopup "${msg_png_finish}" 5
}

pngalpha () {
	dpi=`kdialog --title "${msg_png_dpi_title}" --caption "${msg_png_dpi_title}" --icon configure --inputbox "${msg_png_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_png_destDir_alpha}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -sDEVICE=pngalpha -r"${dpi}" -sOutputFile="${msg_png_destDir_alpha}/page_%0d.png" "${1}" && \
	kdialog --title "${msg_png_finish_title}" --passivepopup "${msg_png_finish}" 5
}

################################################

jpeggray () {
	dpi=`kdialog --title "${msg_jpg_dpi_title}" --caption "${msg_jpg_dpi_title}" --icon configure --inputbox "${msg_jpg_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_jpg_destDir_gray}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -dMaxStripSize=8192 -sDEVICE=jpeggray -r"${dpi}" -sOutputFile="${msg_jpg_destDir_gray}/page_%0d.jpeg" "${1}" && \
	kdialog --title "${msg_jpg_finish_title}" --passivepopup "${msg_jpg_finish}" 5
}

jpeg () {
	dpi=`kdialog --title "${msg_jpg_dpi_title}" --caption "${msg_jpg_dpi_title}" --icon configure --inputbox "${msg_jpg_dpi_text}" "72x72"` || exit
	mkdir -p "${msg_jpg_destDir_color}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -dMaxStripSize=8192 -sDEVICE=jpeg -r"${dpi}" -sOutputFile="${msg_jpg_destDir_color}/page_%0d.jpeg" "${1}" && \
	kdialog --title "${msg_jpg_finish_title}" --passivepopup "${msg_jpg_finish}" 5
}

################################################

tiffg3 () {
	mkdir -p "${msg_fax_destDir_tiffg3}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -dMaxStripSize=8192 -sDEVICE=tiffg3 -sOutputFile="${msg_fax_destDir_tiffg3}/page_%0d.tiff" "${1}" && \
	kdialog --title "${msg_fax_finish_title}" --passivepopup "${msg_fax_finish}" 5
}

tiffg32d () {
	mkdir -p "${msg_fax_destDir_tiffg32d}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -dMaxStripSize=8192 -sDEVICE=tiffg32d -sOutputFile="${msg_fax_destDir_tiffg32d}/page_%0d.tiff" "${1}" && \
	kdialog --title "${msg_fax_finish_title}" --passivepopup "${msg_fax_finish}" 5
}

tiffg4 () {
	mkdir -p "${msg_fax_destDir_tiffg4}" || ( kdialog --icon folder --error "${msg_createDir_error}" && exit )
	gs -dSAFER -dBATCH -dNOPAUSE -q -dTextAlphaBits=4 -dGraphicsAlphaBits=4 -dMaxStripSize=8192 -sDEVICE=tiffg4 -sOutputFile="${msg_fax_destDir_tiffg4}/page_%0d.tiff" "${1}" && \
	kdialog --title "${msg_fax_finish_title}" --passivepopup "${msg_fax_finish}" 5
}

#### main

cd "${workDir}"
    "load_language_${lang}" || load_language_en
    "${action}" "${@}"
cd -
