#!/usr/bin/sh
#
# 	Part of kde-service-menu-pdf Version 0.6
# 	Copyright (C) 2014 Giuseppe Benigno <giuseppe.benigno(at)gmail.com>
#
# 	This program is free software: you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation, either version 3 of the License, or
# 	(at your option) any later version.
#
# 	This program is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

lang=`echo "${1}" | sed -e "s/@//g"`
shift
action="${1}"
shift
workDir="${1%/*}"; if [ ! -d "${workDir}" ]; then workDir="./"; fi
fileName="${1##*/}"
baseFileName="${fileName%.*}"

#### languages strings messages #################
# Syntax for strings name is: msg_[$action]_$window_[$section]
# For languages as sr@Latn use srLatn

load_language_en () {
	msg_insertPasswd_title="Insert password"
	msg_insertPasswd_usr="Please insert user password of document \"${baseFileName}\":"
	msg_insertPasswd_own="Please insert main password of document \"${baseFileName}\":"

	msg_inputPagesRange_title="Input pages range"
	#msg_inputPagesRange="Notes: The keyword \"end\" may be used to reference the final page of a document instead of a page number.\n\nPlease input page range to convert from \"${baseFileName}\":"
	msg_inputPagesRange="Notes: The keyword \"end\" may be used to reference the final page of a document instead of a page number. Please input page range to convert from \"${baseFileName}\":"

	msg_options_title="Preferences"
	msg_options="Select options for conversion of \"${baseFileName}\""
	msg_options_ReplaceLinks="Excange .pdf links with .html"
	msg_options_NoImages="Ignore images"
	msg_options_NoFrames="Generate no frames (all in one page)"
	msg_options_ForceHiddenText="Force hidden text extraction"
	msg_options_NoMerge="Do not merge paragraphs"
	msg_options_NoDRM="Override document DRM (Digital Restrictions Management) setting"

	msg_saveFile_title="Save document"

	msg_all_finish_title="Conversion of all pages the document \"${baseFileName}\""
	msg_selected_finish_title="Conversion of selected pages of document \"${baseFileName}\""
	msg_finish="Done."
}

load_language_it () {
	msg_insertPasswd_title="Inserisci password"
	msg_insertPasswd_usr="Per favore digita la password utente per \"${baseFileName}\":"
	msg_insertPasswd_own="Per favore digita la password principale \"${baseFileName}\":"

	msg_inputPagesRange_title="Selezione range"
	#msg_inputPagesRange="Nota: La parola chiave \"end\" può essere usata per indicare la pagina finale di un documento al posto di un valore numerico.\n\nPer favore inserisci il range di pagine da estrarre da \"${baseFileName}\":"
	msg_inputPagesRange="Nota: La parola chiave \"end\" può essere usata per indicare la pagina finale di un documento al posto di un valore numerico. Per favore inserisci il range di pagine da estrarre da \"${baseFileName}\":"

	msg_options_title="Preferenze"
	msg_options="Seleziona le opzioni per la conversione di \"${baseFileName}\""
	msg_options_ReplaceLinks="Sostituisci i collegamenti .pdf con .html"
	msg_options_NoImages="Ignora le immagini"
	msg_options_NoFrames="Non generare frames (tutto in una pagina)"
	msg_options_ForceHiddenText="Forza l'estrazione del testo nascosto"
	msg_options_NoMerge="Non unire i paragrafi"
	msg_options_NoDRM="Ignora le impostazioni DRM (Digital Restrictions Management)"

	msg_saveFile_title="Salva documento"

	msg_all_finish_title="Conversione di tutte le pagine del documento \"${baseFileName}\""
	msg_selected_finish_title="Conversione delle pagine selezionate del documento \"${baseFileName}\""
	msg_finish="Conclusa."
}

load_language_de () {
	msg_insertPasswd_title="Passwort eingeben"
	msg_insertPasswd_usr="Bitte das Benutzerpasswort für \"${baseFileName}\" eingeben:"
	msg_insertPasswd_own="Bitte das Masterpasswort für \"${baseFileName}\" eingeben:"

	msg_inputPagesRange_title="Seitenbereich eingeben"
	#msg_inputPagesRange="Notes: The keyword \"end\" may be used to reference the final page of a document instead of a page number.\n\nPlease input page range to convert from \"${baseFileName}\":"
	msg_inputPagesRange="Beachte: Das Schlüsselwort \"end\" kann für die letzte Seite benutzt werden, anstatt deren Seitenzahl anzugeben. Bitte Seitenbereich von \"${baseFileName}\" angeben, der umgewandelt werden soll:"

	msg_options_title="Eigenschaften"
	msg_options="Optionen für die Umwandlung von \"${baseFileName}\" auswählen"
	msg_options_ReplaceLinks=".pdf Links mit .html vertauschen"
	msg_options_NoImages="Bilder ignorieren"
	msg_options_NoFrames="Keine Rahmen erstellen (Alles auf einer Seite)"
	msg_options_ForceHiddenText="Versteckten Text mit herausziehen"
	msg_options_NoMerge="Abschnitte nicht zusammensetzen"
	msg_options_NoDRM="DRM-Einstellungen (Digital Restrictions Management) des Dokumentes überschreiben"

	msg_saveFile_title="Dokument speichern"

	msg_all_finish_title="Alle Seiten von \"${baseFileName}\" umwandeln"
	msg_selected_finish_title="Ausgewählte Seiten von \"${baseFileName}\" umwandeln"
	msg_finish="Fertig."
}

load_language_ru () {
	msg_insertPasswd_title="Вставить пароль"
	msg_insertPasswd_usr="Пожалуйста, вставьте пароль пользователя для документа \"${baseFileName}\":"
	msg_insertPasswd_own="Пожалуйста, вставьте основной пароль для документа \"${baseFileName}\":"

	msg_inputPagesRange_title="Диапазон входящих страниц"
	#msg_inputPagesRange="Notes: The keyword \"end\" may be used to reference the final page of a document instead of a page number.\n\nPlease input page range to convert from \"${baseFileName}\":"
	msg_inputPagesRange="Примечание: Ключевое слово \"end\" может использоваться, чтобы сослаться на заключительную страницу документа вместо номера страницы. Пожалуйста, вставьте диапазон страниц для преобразования из \"${baseFileName}\":"

	msg_options_title="Параметры"
	msg_options="Выбор параметров для конвертации \"${baseFileName}\""
	msg_options_ReplaceLinks="Заменить ссылки с .pdf на .html"
	msg_options_NoImages="Игнорировать изображения"
	msg_options_NoFrames="Исключить создание кадров (все на одной странице)"
	msg_options_ForceHiddenText="Принудительно извлекать скрытый текст"
	msg_options_NoMerge="Не объединять абзацы"
	msg_options_NoDRM="Переопределить настройки DRM документа (технические средства защиты авторских прав)"

	msg_saveFile_title="Сохранить документ"

	msg_all_finish_title="Преобразование всех страниц документа \"${baseFileName}\""
	msg_selected_finish_title="Преобразование выбранных страниц документа \"${baseFileName}\""
	msg_finish="Готово."
}

################################################

all () {
	options=`kdialog --title "${msg_options_title}" --caption "${msg_options_title}" --icon configure --checklist "${msg_options}" _p "${msg_options_ReplaceLinks}" on _i "${msg_options_NoImages}" off _noframes "${msg_options_NoFrames}" on _hidden "${msg_options_ForceHiddenText}" off _nomerge "${msg_options_NoMerge}" off _nodrm "${msg_options_NoDRM}" on --separate-output` || exit
	options=`echo ${options} | sed 'y/_/-/'`
	outputFileName=`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${baseFileName}.html" text/html` || exit
	pdftohtml ${options} "${@}" "${outputFileName}" && \
	kdialog --title "${msg_all_finish_title}" --passivepopup "${msg_finish}" 5
}

all_usr () {
	usr_passwd=`kdialog --title "${msg_insertPasswd_title}" --caption "${msg_insertPasswd_title}" --password "${msg_insertPasswd_usr}"` || exit
	usr_passwd=`echo ${usr_passwd} |grep '^.' |sed 's/^/-upw /'`
	options=`kdialog --title "${msg_options_title}" --caption "${msg_options_title}" --icon configure --checklist "${msg_options}" _p "${msg_options_ReplaceLinks}" on _i "${msg_options_NoImages}" off _noframes "${msg_options_NoFrames}" on _hidden "${msg_options_ForceHiddenText}" off _nomerge "${msg_options_NoMerge}" off _nodrm "${msg_options_NoDRM}" on --separate-output` || exit
	options=`echo ${options} | sed 'y/_/-/'`
	outputFileName=`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${baseFileName}.html" text/html` || exit
	pdftohtml ${options} "${usr_passwd}" "${@}" "${outputFileName}" && \
	kdialog --title "${msg_all_finish_title}" --passivepopup "${msg_finish}" 5
}

all_own () {
	own_passwd=`kdialog --title "${msg_insertPasswd_title}" --caption "${msg_insertPasswd_title}" --password "${msg_insertPasswd_own}"` || exit
	own_passwd=`echo ${own_passwd} |grep '^.' |sed 's/^/-opw /'`
	options=`kdialog --title "${msg_options_title}" --caption "${msg_options_title}" --icon configure --checklist "${msg_options}" _p "${msg_options_ReplaceLinks}" on _i "${msg_options_NoImages}" off _noframes "${msg_options_NoFrames}" on _hidden "${msg_options_ForceHiddenText}" off _nomerge "${msg_options_NoMerge}" off _nodrm "${msg_options_NoDRM}" on --separate-output` || exit
	options=`echo ${options} | sed 'y/_/-/'`
	outputFileName=`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${baseFileName}.html" text/html` || exit
	pdftohtml ${options} "${own_passwd}" "${@}" "${outputFileName}" && \
	kdialog --title "${msg_all_finish_title}" --passivepopup "${msg_finish}" 5
}

selected () {
	range=`kdialog --title "${msg_inputPagesRange_title}" --caption "${msg_inputPagesRange_title}" --icon edit-copy --inputbox "${msg_inputPagesRange}" "1-end"` || exit
	range=`echo "${range}" | sed 's/[[:blank:]]*//g' | sed 's/-end//' | sed 's/\(^[0-9][0-9]*\)/-f \1/' | sed 's/\(^-f [0-9][0-9]*\)-\([0-9][0-9]*\)/\1 -l \2/'| sed 's/^-\([0-9][0-9]*\)/-l \1/'`
	options=`kdialog --title "${msg_options_title}" --caption "${msg_options_title}" --icon configure --checklist "${msg_options}" _p "${msg_options_ReplaceLinks}" on _i "${msg_options_NoImages}" off _noframes "${msg_options_NoFrames}" on _hidden "${msg_options_ForceHiddenText}" off _nomerge "${msg_options_NoMerge}" off _nodrm "${msg_options_NoDRM}" on --separate-output` || exit
	options=`echo ${options} | sed 'y/_/-/'`
	outputFileName=`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${baseFileName}.html" text/html` || exit
	pdftohtml ${options} ${range} "${@}" "${outputFileName}" && \
	kdialog --title "${msg_selected_finish_title}" --passivepopup "${msg_finish}" 5
}

selected_usr () {
	usr_passwd=`kdialog --title "${msg_insertPasswd_title}" --caption "${msg_insertPasswd_title}" --password "${msg_insertPasswd_usr}"` || exit
	usr_passwd=`echo ${usr_passwd} |grep '^.' |sed 's/^/-upw /'`
	range=`kdialog --title "${msg_inputPagesRange_title}" --caption "${msg_inputPagesRange_title}" --icon edit-copy --inputbox "${msg_inputPagesRange}" "1-end"` || exit
	range=`echo "${range}" | sed 's/[[:blank:]]*//g' | sed 's/-end//' | sed 's/\(^[0-9][0-9]*\)/-f \1/' | sed 's/\(^-f [0-9][0-9]*\)-\([0-9][0-9]*\)/\1 -l \2/'| sed 's/^-\([0-9][0-9]*\)/-l \1/'`
	options=`kdialog --title "${msg_options_title}" --caption "${msg_options_title}" --icon configure --checklist "${msg_options}" _p "${msg_options_ReplaceLinks}" on _i "${msg_options_NoImages}" off _noframes "${msg_options_NoFrames}" on _hidden "${msg_options_ForceHiddenText}" off _nomerge "${msg_options_NoMerge}" off _nodrm "${msg_options_NoDRM}" on --separate-output` || exit
	options=`echo ${options} | sed 'y/_/-/'`
	outputFileName=`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${baseFileName}.html" text/html` || exit
	pdftohtml ${options} "${usr_passwd}" ${range} "${@}" "${outputFileName}" && \
	kdialog --title "${msg_selected_finish_title}" --passivepopup "${msg_finish}" 5
}

selected_own () {
	own_passwd=`kdialog --title "${msg_insertPasswd_title}" --caption "${msg_insertPasswd_title}" --password "${msg_insertPasswd_own}"` || exit
	own_passwd=`echo ${own_passwd} |grep '^.' |sed 's/^/-opw /'`
	range=`kdialog --title "${msg_inputPagesRange_title}" --caption "${msg_inputPagesRange_title}" --icon edit-copy --inputbox "${msg_inputPagesRange}" "1-end"` || exit
	range=`echo "${range}" | sed 's/[[:blank:]]*//g' | sed 's/-end//' | sed 's/\(^[0-9][0-9]*\)/-f \1/' | sed 's/\(^-f [0-9][0-9]*\)-\([0-9][0-9]*\)/\1 -l \2/'| sed 's/^-\([0-9][0-9]*\)/-l \1/'`
	options=`kdialog --title "${msg_options_title}" --caption "${msg_options_title}" --icon configure --checklist "${msg_options}" _p "${msg_options_ReplaceLinks}" on _i "${msg_options_NoImages}" off _noframes "${msg_options_NoFrames}" on _hidden "${msg_options_ForceHiddenText}" off _nomerge "${msg_options_NoMerge}" off _nodrm "${msg_options_NoDRM}" on --separate-output` || exit
	options=`echo ${options} | sed 'y/_/-/'`
	outputFileName=`kdialog --title "${msg_saveFile_title}" --caption "${msg_saveFile_title}" --icon document-save --getsavefilename "${workDir}/${baseFileName}.html" text/html` || exit
	pdftohtml ${options} "${own_passwd}" ${range} "${@}" "${outputFileName}" && \
	kdialog --title "${msg_selected_finish_title}" --passivepopup "${msg_finish}" 5
}

#### main

cd "${workDir}"
    "load_language_${lang}" || load_language_en
	"${action}" "${@}"
cd -
